Create wizard using accordion in EJ2 JavaScript Accordion control

23 Jun 202323 minutes to read

Accordion items can be disabled dynamically by passing the index and boolean value with the enableItem method and also dynamically expand the item using expandItem method.

The below Wizard sample is designed for Online Shopping model. In this, each Accordion item is integrated with required components to fill
the details and designed for getting user details and making payment at the end. Each field is provided with validation for all mandatory
option to enable/disable to next Accordion. In below sample, accordion items can be disabled dynamically with enableItem method using created event.

ej.base.enableRipple(true);

var success = 'Your payment successfully processed';
var email_alert = 'Enter valid email address';
var mobile_alert = 'Mobile number length should be 10';
var card_alert = 'Card number length should be 16';
var cvv_alert = 'CVV number length should be 3';

var mobile = new ej.inputs.NumericTextBox({
  placeholder: 'Mobile',
  floatLabelType: 'Auto',
  format: '0',
  showSpinButton: false
});
mobile.appendTo('#mobile');

var cardNum = new ej.inputs.NumericTextBox({
  placeholder: 'Card No',
  floatLabelType: 'Auto',
  format: '0',
  showSpinButton: false
});
cardNum.appendTo('#cardNo');

var datepicker = new ej.calendars.DatePicker({
  width: '100%',
  format: 'MM/yyyy',
  floatLabelType: 'Auto',
  placeholder: 'Expiry Date'
});
datepicker.appendTo('#expiry');

var cvv = new ej.inputs.NumericTextBox({
  placeholder: 'CVV',
  floatLabelType: 'Auto',
  format: '0',
  showSpinButton: false
});
cvv.appendTo('#CVV');

var alertDialog = new ej.popups.Dialog({
  header: 'Alert',
  width: 200,
  isModal: true,
  content: '',
  target: document.body,
  buttons: [{
    buttonModel: { content: 'Ok', isPrimary: true },
    click: (() => {
      alertDialog.hide();
      if (acrdnObj.expandedIndices[0] === 2 && alertDialog.content === success) {
        acrdnObj.enableItem(0, true);
        acrdnObj.enableItem(1, false);
        acrdnObj.enableItem(2, false);
        acrdnObj.expandItem(true, 0);
      }
    })
  }]
});
alertDialog.appendTo('#alertDialog');
alertDialog.hide();

var acrdnObj = new ej.navigations.Accordion({
  expanding: expand,
  created: () => {

  },
  items: [
    { header: 'Sign In', content: '#Sign_In_Form', expanded: true },
    { header: 'Delivery Address', content: '#Address_Fill' },
    { header: 'Card Details', content: '#Card_Fill' },
  ]
});
acrdnObj.appendTo('#element');

function checkMail(mail) {
  if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(mail)) {
    return (true);
  } else {
    alertDialog.content = email_alert;
    alertDialog.show();
    return (false);
  }
}

function checkMobile(mobile) {
  if (mobile.match(/^\d{10}$/)) {
    return (true);
  } else {
    alertDialog.content = mobile_alert;
    alertDialog.show();
    return (false);
  }
}

function checkCardNo(cardNo) {
  if (cardNo.match(/^\d{16}$/)) {
    return (true);
  } else {
    alertDialog.content = card_alert;
    alertDialog.show();
    return (false);
  }
}

function checkCVV(cvv) {
  if (cvv.match(/^\d{3}$/)) {
    return (true);
  } else {
    alertDialog.content = cvv_alert;
    alertDialog.show();
    return (false);
  }
}

function expand(e) {
  if (e.name === 'expanding' && [].indexOf.call(this.items, e.item) === 0) {
    document.getElementById('Continue_Btn').onclick = (e) => {
      var email = document.getElementById('email');
      var password = document.getElementById('password');
      if (email.value !== '' && password.value !== '') {
        if (checkMail(email.value)) {
          email.value = password.value = '';
          acrdnObj.enableItem(1, true);
          acrdnObj.enableItem(0, false);
          acrdnObj.expandItem(true, 1);
        }
        document.getElementById('err1').classList.remove('show');
      } else {
        document.getElementById('err1').classList.add('show');
      } 
    };
  } else if (e.name === 'expanding' && [].indexOf.call(this.items, e.item) === 1) {
    document.getElementById('Continue_BtnAdr').onclick = (e) => {
      var name = document.getElementById('name');
      var address = document.getElementById('address');
      var mobile = document.getElementById('mobile');
      if ((name.value !== '') && (address.value !== '') && (mobile.value !== '')) {
        if (checkMobile(mobile.value)) {
          acrdnObj.enableItem(2, true);
          acrdnObj.enableItem(1, false);
          acrdnObj.expandItem(true, 2);
        }
        document.getElementById('err2').classList.remove('show');
      } else {
        document.getElementById('err2').classList.add('show');
      }
    };
  } else if (e.name === 'expanding' && [].indexOf.call(this.items, e.item) === 2) {
    document.getElementById('Back_Btn').onclick = (e) => {
      acrdnObj.enableItem(1, true);
      acrdnObj.enableItem(2, false);
      acrdnObj.expandItem(true, 1);
    };
    document.getElementById('Save_Btn').onclick = (e) => {
      var cardHolder = document.getElementById('cardHolder');
      var expiry = document.getElementById('expiry');
      var cardNo = document.getElementById('cardNo');
      var cvv = document.getElementById('CVV');
      if ((cardNo.value !== '') && (cardHolder.value !== '') && (expiry.value !== '') && (cvv.value !== '')) {
        if (checkCardNo(cardNo.value)) {
          if (checkCVV(cvv.value)) {
            alertDialog.content = success;
            alertDialog.show();
          }
        }
        document.getElementById('err3').classList.remove('show');
      } else {
        document.getElementById('err3').classList.add('show');
      }
    };
  }
}
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 Accordion</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Toolbar Controls">
    <meta name="author" content="Syncfusion">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/material.css" rel="stylesheet">
    <style>
        #container {
            max-width: 450px;
            margin: 0 auto;
        }
    
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    
        .accordion-control-section {
            margin: 0 10% 0 10%;
        }
    
        @media screen and (max-width: 768px) {
            .accordion-control-section {
                margin: 0;
            }
        }
    
        #err1,
        #err2,
        #err3 {
            display: none;
            color: red;
            margin-top: 10px;
            font-weight: 500;
        }
    
        #err1.show,
        #err2.show,
        #err3.show {
            display: block;
        }
    
        .e-dialog {
            max-height: 300px !important;
            /* csslint allow: important */
        }
    
        .template_title {
            text-align: center;
            padding: 10px 0;
            margin: 20px 0;
            text-overflow: ellipsis;
            font-weight: bold;
            font-size: 16px;
        }
    </style>
    
    
<script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div class="template_title"> Online Shopping Payment Module</div>
        <div id="element"></div>
        <div id="result"></div>
    </div>
    <div id="Sign_In_Form" style="display: none; padding: 3px 0">
        <form id="formId">
            <div class="form-group">
                <div class="e-float-input">
                    <input type="text" id="email" name="Email" required="">
                    <span class="e-float-line"></span>
                    <label class="e-float-text" for="email">Email</label>
                </div>
                <div class="e-float-input">
                    <input class="e-input" id="password" type="password" name="Password" required="">
                    <span class="e-float-line"></span>
                    <label class="e-float-text" for="password">Password</label>
                </div>
            </div>
        </form>
        <div style="text-align: center">
            <button class="e-btn" id="Continue_Btn">Continue</button>
            <div id="err1">* Please fill all fields</div>
        </div>
    </div>
    <div id="Address_Fill" style="display: none; padding: 3px 0">
        <form id="formId_Address">
            <div class="form-group">
                <div class="e-float-input">
                    <input type="text" id="name" name="Name" required="">
                    <span class="e-float-line"></span>
                    <label class="e-float-text" for="name">Name</label>
                </div>
            </div>
            <div class="form-group">
                <div class="e-float-input">
                    <input type="text" id="address" name="Address" required="">
                    <span class="e-float-line"></span>
                    <label class="e-float-text" for="address">Address</label>
                </div>
            </div>
            <div class="form-group">
              <input type="text" id="mobile">
            </div>
        </form>
        <div style="text-align: center">
            <button class="e-btn" id="Continue_BtnAdr">Continue</button>
            <div id="err2">* Please fill all fields</div>
        </div>
    </div>
    <div id="Card_Fill" style="display: none; padding: 3px 0;">
        <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6">
            <div class="form-group">
                <input type="text" id="cardNo">
            </div>
        </div>
        <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6">
            <div class="form-group">
                <div class="e-float-input">
                    <input type="text" id="cardHolder" name="cardHolder" required="">
                    <span class="e-float-line"></span>
                    <label class="e-float-text" for="cardHolder">CardHolder Name</label>
                </div>
            </div>
        </div>
        <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6">
            <input id="expiry">
        </div>
        <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6">
            <div class="form-group">
              <input type="text" id="CVV">
            </div>
        </div>
        <div style="text-align: center">
            <button class="e-btn" id="Back_Btn">Back</button>
            <button class="e-btn" id="Save_Btn">Save</button>
            <div id="err3">* Please fill all fields</div>
        </div>
    </div>
    <div id="alertDialog"></div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Create wizard using accordion in Vue Accordion component

25 May 202424 minutes to read

Accordion items can be disabled dynamically by passing the index and boolean value with the enableItem method.

The below Wizard sample is designed for Online Shopping model. In this, each Accordion item is integrated with required components to fill
the details and designed for getting user details and making payment at the end. Each field is provided with validation for all mandatory
option to enable/disable to next Accordion.

<template>
  <div id="app">
    <div id="Sign_In_Form" style="display: none; padding: 3px 0">
      <form id="formId">
        <div class="form-group">
          <div class="e-float-input">
            <input type="text" id="email" name="Email" required="" />
            <span class="e-float-line"></span>
            <label class="e-float-text" for="email">Email</label>
          </div>
          <div class="e-float-input">
            <input id="password" type="password" name="Password" required="" />
            <span class="e-float-line"></span>
            <label class="e-float-text" for="password">Password</label>
          </div>
        </div>
      </form>
      <div style="text-align: center">
        <button class="e-btn" id="Continue_Btn">Continue</button>
        <div id="err1">* Please fill all fields</div>
      </div>
    </div>
    <div id="Address_Fill" style="display: none; padding: 3px 0">
      <form id="formId_Address">
        <div class="form-group">
          <div class="e-float-input">
            <input type="text" id="name" name="Name" required="" />
            <span class="e-float-line"></span>
            <label class="e-float-text" for="name">Name</label>
          </div>
        </div>
        <div class="form-group">
          <div class="e-float-input">
            <input type="text" id="address" name="Address" required="" />
            <span class="e-float-line"></span>
            <label class="e-float-text" for="address">Address</label>
          </div>
        </div>
        <div class="form-group">
          <ejs-numerictextbox id="mobile" format="0" placeholder="Mobile" floatLabelType="Auto" showSpinButton="false">
          </ejs-numerictextbox>
        </div>
      </form>
      <div style="text-align: center">
        <button class="e-btn" id="Continue_BtnAdr">Continue</button>
        <div id="err2">* Please fill all fields</div>
      </div>
    </div>
    <div id="Card_Fill" style="display: none; padding: 3px 0">
      <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6">
        <div class="form-group">
          <ejs-numerictextbox id="cardNo" format="0" placeholder="Card No" floatLabelType="Auto" showSpinButton="false">
          </ejs-numerictextbox>
        </div>
      </div>
      <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6">
        <div class="form-group">
          <div class="e-float-input">
            <input type="text" id="cardHolder" name="cardHolder" required="" />
            <span class="e-float-line"></span>
            <label class="e-float-text" for="cardHolder">CardHolder Name</label>
          </div>
        </div>
      </div>
      <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6">
        <ejs-datepicker id="expiry" width="100%" format="MM/yyyy" placeholder="Expiry Date" floatLabelType="Auto">
        </ejs-datepicker>
      </div>
      <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6">
        <div class="form-group">
          <ejs-numerictextbox id="CVV" format="0" placeholder="CVV" floatLabelType="Auto" showSpinButton="false">
          </ejs-numerictextbox>
        </div>
      </div>
      <div style="text-align: center">
        <button class="e-btn" id="Back_Btn">Back</button>
        <button class="e-btn" id="Save_Btn">Save</button>
        <div id="err3">* Please fill all fields</div>
      </div>
    </div>
    <ejs-dialog ref="alertDlg" header="Alert" width="200" isModal="true" content="" visible="false" :target="dlgTarget"
      :buttons="dlgButtons" :created="dlgCreated"></ejs-dialog>
    <ejs-accordion ref="accordionInc" :expanding="expanding">
      <e-accordionitems>
        <e-accordionitem expanded="true" header="Sign In" content="#Sign_In_Form"></e-accordionitem>
        <e-accordionitem header="Delivery Address" content="#Address_Fill"></e-accordionitem>
        <e-accordionitem header="Card Details" content="#Card_Fill"></e-accordionitem>
      </e-accordionitems>
    </ejs-accordion>
  </div>
</template>
<script setup>

import { AccordionComponent as EjsAccordion, AccordionItemDirective as EAccordionitem, AccordionItemsDirective as EAccordionitems } from "@syncfusion/ej2-vue-navigations";
import { DialogComponent as EjsDialog } from "@syncfusion/ej2-vue-popups";
import { DatePickerComponent as EjsDatepicker } from "@syncfusion/ej2-vue-calendars";
import { NumericTextBoxComponent as EjsNumerictextbox } from "@syncfusion/ej2-vue-inputs";
import { ref } from 'vue';

const alertDlg = ref(null);
const accordionInc = ref(null);
const dlgButtons = [
  {
    buttonModel: { content: "Ok", isPrimary: true },
    click: () => {
      alertDlg.value.ej2Instances.hide();
      var obj1 = accordionInc.value.ej2Instances;
      if (
        obj1.expandedIndices[0] === 2 &&
        alertDlg.value.ej2Instances.content ===
        "Your payment successfully processed"
      ) {
        obj1.enableItem(0, true);
        obj1.enableItem(1, false);
        obj1.enableItem(2, false);
        obj1.expandItem(true, 0);
      }
    },
  },
];
const dlgTarget = document.body;
const checkMail = (mail) => {
  //eslint-disable-next-line
  if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(mail)) {
    return true;
  } else {
    alertDlg.value.ej2Instances.content = "Enter valid email address";
    alertDlg.value.ej2Instances.show();
    return false;
  }
};
const checkMobile = (mobile) => {
  if (mobile.match(/^\d{10}$/)) {
    return true;
  } else {
    alertDlg.value.ej2Instances.content =
      "Mobile number length should be 10";
    alertDlg.value.ej2Instances.show();
    return false;
  }
};
const checkCardNo = (cardNo) => {
  if (cardNo.match(/^\d{16}$/)) {
    return true;
  } else {
    alertDlg.value.ej2Instances.content =
      "Card number length should be 16";
    alertDlg.value.ej2Instances.show();
    return false;
  }
};
const checkCVV = (cvv) => {
  if (cvv.match(/^\d{3}$/)) {
    return true;
  } else {
    alertDlg.value.ej2Instances.content =
      "CVV number length should be 3";
    alertDlg.value.ej2Instances.show();
    return false;
  }
};
const dlgCreated = () => {
  alertDlg.value.ej2Instances.hide();
};
const expanding = (e) => {
  if (
    e.name === "expanding" &&
    [].indexOf.call(accordionInc.value.ej2Instances.items, e.item) ===
    0
  ) {
    document.getElementById("Continue_Btn").onclick = () => {
      var email = document.getElementById("email");
      var password = document.getElementById("password");
      if (email.value !== "" && password.value !== "") {
        if (checkMail(email.value)) {
          email.value = password.value = "";
          var acrdnObj = accordionInc.value.ej2Instances;
          acrdnObj.enableItem(1, true);
          acrdnObj.enableItem(0, false);
          acrdnObj.expandItem(true, 1);
        }
        document.getElementById("err1").classList.remove("show");
      } else {
        document.getElementById("err1").classList.add("show");
      }
    };
  } else if (
    e.name === "expanding" &&
    [].indexOf.call(accordionInc.value.ej2Instances.items, e.item) ===
    1
  ) {
    document.getElementById("Continue_BtnAdr").onclick = () => {
      var name = document.getElementById("name");
      var address = document.getElementById("address");
      var mobile = document.getElementById("mobile");
      if (
        name.value !== "" &&
        address.value !== "" &&
        mobile.value !== ""
      ) {
        if (checkMobile(mobile.value)) {
          var acrdnObj = accordionInc.value.ej2Instances;
          acrdnObj.enableItem(2, true);
          acrdnObj.enableItem(1, false);
          acrdnObj.expandItem(true, 2);
        }
        document.getElementById("err2").classList.remove("show");
      } else {
        document.getElementById("err2").classList.add("show");
      }
    };
  } else if (
    e.name === "expanding" &&
    [].indexOf.call(accordionInc.value.ej2Instances.items, e.item) ===
    2
  ) {
    document.getElementById("Back_Btn").onclick = () => {
      var acrdnObj = accordionInc.value.ej2Instances;
      acrdnObj.enableItem(1, true);
      acrdnObj.enableItem(2, false);
      acrdnObj.expandItem(true, 1);
    };
    document.getElementById("Save_Btn").onclick = () => {
      var cardHolder = document.getElementById("cardHolder");
      var expiry = document.getElementById("expiry");
      var cardNo = document.getElementById("cardNo");
      var cvv = document.getElementById("CVV");
      if (
        cardNo.value !== "" &&
        cardHolder.value !== "" &&
        expiry.value !== "" &&
        cvv.value !== ""
      ) {
        if (checkCardNo(cardNo.value)) {
          if (checkCVV(cvv.value)) {
            alertDlg.value.ej2Instances.content =
              "Your payment successfully processed";
            alertDlg.value.ej2Instances.show();
          }
        }
        document.getElementById("err3").classList.remove("show");
      } else {
        document.getElementById("err3").classList.add("show");
      }
    };
  }
};

</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";

#err1,
#err2,
#err3 {
  display: none;
  color: red;
  margin-top: 10px;
  font-weight: 500;
}

#err1.show,
#err2.show,
#err3.show {
  display: block;
}

.e-dialog {
  max-height: 300px !important;
  /* csslint allow: important */
}

.template_title {
  text-align: center;
  padding: 10px 0;
  margin: 20px 0;
  text-overflow: ellipsis;
  font-weight: bold;
  font-size: 16px;
}
</style>
<template>
  <div id="app">
    <div id="Sign_In_Form" style="display: none; padding: 3px 0">
      <form id="formId">
        <div class="form-group">
          <div class="e-float-input">
            <input type="text" id="email" name="Email" required="" />
            <span class="e-float-line"></span>
            <label class="e-float-text" for="email">Email</label>
          </div>
          <div class="e-float-input">
            <input id="password" type="password" name="Password" required="" />
            <span class="e-float-line"></span>
            <label class="e-float-text" for="password">Password</label>
          </div>
        </div>
      </form>
      <div style="text-align: center">
        <button class="e-btn" id="Continue_Btn">Continue</button>
        <div id="err1">* Please fill all fields</div>
      </div>
    </div>
    <div id="Address_Fill" style="display: none; padding: 3px 0">
      <form id="formId_Address">
        <div class="form-group">
          <div class="e-float-input">
            <input type="text" id="name" name="Name" required="" />
            <span class="e-float-line"></span>
            <label class="e-float-text" for="name">Name</label>
          </div>
        </div>
        <div class="form-group">
          <div class="e-float-input">
            <input type="text" id="address" name="Address" required="" />
            <span class="e-float-line"></span>
            <label class="e-float-text" for="address">Address</label>
          </div>
        </div>
        <div class="form-group">
          <ejs-numerictextbox id="mobile" format="0" placeholder="Mobile" floatLabelType="Auto" showSpinButton="false">
          </ejs-numerictextbox>
        </div>
      </form>
      <div style="text-align: center">
        <button class="e-btn" id="Continue_BtnAdr">Continue</button>
        <div id="err2">* Please fill all fields</div>
      </div>
    </div>
    <div id="Card_Fill" style="display: none; padding: 3px 0">
      <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6">
        <div class="form-group">
          <ejs-numerictextbox id="cardNo" format="0" placeholder="Card No" floatLabelType="Auto" showSpinButton="false">
          </ejs-numerictextbox>
        </div>
      </div>
      <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6">
        <div class="form-group">
          <div class="e-float-input">
            <input type="text" id="cardHolder" name="cardHolder" required="" />
            <span class="e-float-line"></span>
            <label class="e-float-text" for="cardHolder">CardHolder Name</label>
          </div>
        </div>
      </div>
      <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6">
        <ejs-datepicker id="expiry" width="100%" format="MM/yyyy" placeholder="Expiry Date" floatLabelType="Auto">
        </ejs-datepicker>
      </div>
      <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6">
        <div class="form-group">
          <ejs-numerictextbox id="CVV" format="0" placeholder="CVV" floatLabelType="Auto" showSpinButton="false">
          </ejs-numerictextbox>
        </div>
      </div>
      <div style="text-align: center">
        <button class="e-btn" id="Back_Btn">Back</button>
        <button class="e-btn" id="Save_Btn">Save</button>
        <div id="err3">* Please fill all fields</div>
      </div>
    </div>
    <ejs-dialog ref="alertDlg" header="Alert" width="200" isModal="true" content="" visible="false" :target="dlgTarget"
      :buttons="dlgButtons" :created="dlgCreated"></ejs-dialog>
    <ejs-accordion ref="accordionInc" :expanding="expanding">
      <e-accordionitems>
        <e-accordionitem expanded="true" header="Sign In" content="#Sign_In_Form"></e-accordionitem>
        <e-accordionitem header="Delivery Address" content="#Address_Fill"></e-accordionitem>
        <e-accordionitem header="Card Details" content="#Card_Fill"></e-accordionitem>
      </e-accordionitems>
    </ejs-accordion>
  </div>
</template>
<script>

import { DialogComponent } from "@syncfusion/ej2-vue-popups";
import { NumericTextBoxComponent } from "@syncfusion/ej2-vue-inputs";
import { AccordionComponent, AccordionItemDirective, AccordionItemsDirective } from "@syncfusion/ej2-vue-navigations";
import { DatePickerComponent } from '@syncfusion/ej2-vue-calendars';

export default {
  name: "App",
  components: {
    "ejs-numerictextbox": NumericTextBoxComponent,
    "ejs-datepicker": DatePickerComponent,
    "ejs-dialog": DialogComponent,
    "ejs-accordion": AccordionComponent,
    "e-accordionitems": AccordionItemsDirective,
    "e-accordionitem": AccordionItemDirective
  },
  data: function () {
    return {
      dlgButtons: [
        {
          buttonModel: { content: "Ok", isPrimary: true },
          click: () => {
            this.$refs.alertDlg.ej2Instances.hide();
            var obj1 = this.$refs.accordionInc.ej2Instances;
            if (
              obj1.expandedIndices[0] === 2 &&
              this.$refs.alertDlg.ej2Instances.content ===
              "Your payment successfully processed"
            ) {
              obj1.enableItem(0, true);
              obj1.enableItem(1, false);
              obj1.enableItem(2, false);
              obj1.expandItem(true, 0);
            }
          },
        },
      ],
      dlgTarget: document.body,
    };
  },
  methods: {
    checkMail: function (mail) {
      //eslint-disable-next-line
      if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(mail)) {
        return true;
      } else {
        this.$refs.alertDlg.ej2Instances.content = "Enter valid email address";
        this.$refs.alertDlg.ej2Instances.show();
        return false;
      }
    },
    checkMobile: function (mobile) {
      if (mobile.match(/^\d{10}$/)) {
        return true;
      } else {
        this.$refs.alertDlg.ej2Instances.content =
          "Mobile number length should be 10";
        this.$refs.alertDlg.ej2Instances.show();
        return false;
      }
    },
    checkCardNo: function (cardNo) {
      if (cardNo.match(/^\d{16}$/)) {
        return true;
      } else {
        this.$refs.alertDlg.ej2Instances.content =
          "Card number length should be 16";
        this.$refs.alertDlg.ej2Instances.show();
        return false;
      }
    },
    checkCVV: function (cvv) {
      if (cvv.match(/^\d{3}$/)) {
        return true;
      } else {
        this.$refs.alertDlg.ej2Instances.content =
          "CVV number length should be 3";
        this.$refs.alertDlg.ej2Instances.show();
        return false;
      }
    },
    dlgCreated: function () {
      this.$refs.alertDlg.ej2Instances.hide();
    },
    expanding: function (e) {
      if (
        e.name === "expanding" &&
        [].indexOf.call(this.$refs.accordionInc.ej2Instances.items, e.item) ===
        0
      ) {
        document.getElementById("Continue_Btn").onclick = () => {
          var email = document.getElementById("email");
          var password = document.getElementById("password");
          if (email.value !== "" && password.value !== "") {
            if (this.checkMail(email.value)) {
              email.value = password.value = "";
              var acrdnObj = this.$refs.accordionInc.ej2Instances;
              acrdnObj.enableItem(1, true);
              acrdnObj.enableItem(0, false);
              acrdnObj.expandItem(true, 1);
            }
            document.getElementById("err1").classList.remove("show");
          } else {
            document.getElementById("err1").classList.add("show");
          }
        };
      } else if (
        e.name === "expanding" &&
        [].indexOf.call(this.$refs.accordionInc.ej2Instances.items, e.item) ===
        1
      ) {
        document.getElementById("Continue_BtnAdr").onclick = () => {
          var name = document.getElementById("name");
          var address = document.getElementById("address");
          var mobile = document.getElementById("mobile");
          if (
            name.value !== "" &&
            address.value !== "" &&
            mobile.value !== ""
          ) {
            if (this.checkMobile(mobile.value)) {
              var acrdnObj = this.$refs.accordionInc.ej2Instances;
              acrdnObj.enableItem(2, true);
              acrdnObj.enableItem(1, false);
              acrdnObj.expandItem(true, 2);
            }
            document.getElementById("err2").classList.remove("show");
          } else {
            document.getElementById("err2").classList.add("show");
          }
        };
      } else if (
        e.name === "expanding" &&
        [].indexOf.call(this.$refs.accordionInc.ej2Instances.items, e.item) ===
        2
      ) {
        document.getElementById("Back_Btn").onclick = () => {
          var acrdnObj = this.$refs.accordionInc.ej2Instances;
          acrdnObj.enableItem(1, true);
          acrdnObj.enableItem(2, false);
          acrdnObj.expandItem(true, 1);
        };
        document.getElementById("Save_Btn").onclick = () => {
          var cardHolder = document.getElementById("cardHolder");
          var expiry = document.getElementById("expiry");
          var cardNo = document.getElementById("cardNo");
          var cvv = document.getElementById("CVV");
          if (
            cardNo.value !== "" &&
            cardHolder.value !== "" &&
            expiry.value !== "" &&
            cvv.value !== ""
          ) {
            if (this.checkCardNo(cardNo.value)) {
              if (this.checkCVV(cvv.value)) {
                this.$refs.alertDlg.ej2Instances.content =
                  "Your payment successfully processed";
                this.$refs.alertDlg.ej2Instances.show();
              }
            }
            document.getElementById("err3").classList.remove("show");
          } else {
            document.getElementById("err3").classList.add("show");
          }
        };
      }
    },
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";

#err1,
#err2,
#err3 {
  display: none;
  color: red;
  margin-top: 10px;
  font-weight: 500;
}

#err1.show,
#err2.show,
#err3.show {
  display: block;
}

.e-dialog {
  max-height: 300px !important;
  /* csslint allow: important */
}

.template_title {
  text-align: center;
  padding: 10px 0;
  margin: 20px 0;
  text-overflow: ellipsis;
  font-weight: bold;
  font-size: 16px;
}
</style>

Create wizard using accordion in React Accordion component

29 Aug 202324 minutes to read

Accordion items can be disabled dynamically by passing the index and boolean value with the ‘enableItem’ method and also dynamically expand the item using expandItem method.

The below Wizard sample is designed for Online Shopping model. In this, each Accordion item is integrated with required components to fill the details and designed for getting user details and making payment at the end. Each field is provided with validation for all mandatory option to enable/disable to next Accordion. In below sample, accordion items can be disabled dynamically with enableItem method using created event.

import * as React from "react";
import { useRef } from "react";
import * as ReactDOM from "react-dom";
import { DialogComponent } from '@syncfusion/ej2-react-popups';
import { DatePickerComponent } from '@syncfusion/ej2-react-calendars';
import { NumericTextBoxComponent } from '@syncfusion/ej2-react-inputs';
import { AccordionComponent, AccordionItemsDirective, AccordionItemDirective } from '@syncfusion/ej2-react-navigations';
const ReactApp = () => {
  let success = "Your payment successfully processed";
  let email_alert = "Enter valid email address";
  let mobile_alert = "Mobile number length should be 10";
  let card_alert = "Card number length should be 16";
  let cvv_alert = "CVV number length should be 3";
  let dlgTarget = document.body;
  const accordion = useRef(null);
  const alertDlg = useRef(null);
  const cardNo = useRef(null);
  const mobile = useRef(null);
  const expiry = useRef(null);
  const cvv = useRef(null);
  const email = useRef(null);
  const password = useRef(null);
  const name = useRef(null);
  const address = useRef(null);
  const cardHolder = useRef(null);
  const err1 = useRef(null);
  const err2 = useRef(null);
  const err3 = useRef(null);
  const dlgButtons = [
    {
      buttonModel: { content: "Ok", isPrimary: true },
      click: () => {
        alertDlg.current.hide();
        if (
          accordion.current.expandedIndices[0] === 2 &&
          alertDlg.current.content === success
        ) {
          accordion.current.enableItem(0, true);
          accordion.current.enableItem(1, false);
          accordion.current.enableItem(2, false);
          accordion.current.expandItem(true, 0);
        }
      }
    }
  ];
  const dlgCreated = () => {
    alertDlg.current.hide();
  }
  const acrdnCreated = () => {
    if (accordion !== undefined) {
      accordion.current.enableItem(1, false);
      accordion.current.enableItem(2, false);
    }
  }
  const btnClick = (e) => {
    switch (e.target.id) {
      case "Continue_Btn":
        if (email.current.value !== "" && password.current.value !== "") {
          if (checkMail(email.current.value)) {
            email.current.value = password.current.value = "";
            accordion.current.enableItem(1, true);
            accordion.current.enableItem(0, false);
            accordion.current.expandItem(true, 1);
          }
          err1.current.classList.remove("show");
        } else {
          err1.current.classList.add("show");
        }
        break;
      case "Continue_BtnAdr":
        if (
          name.current.value !== "" &&
          address.current.value !== "" &&
          mobile.current.value != null
        ) {
          if (checkMobile(mobile.current.value)) {
            accordion.current.enableItem(2, true);
            accordion.current.enableItem(1, false);
            accordion.current.expandItem(true, 2);
          }
          err2.current.classList.remove("show");
        } else {
          err2.current.classList.add("show");
        }
        break;
      case "Back_Btn":
        accordion.current.enableItem(1, true);
        accordion.current.enableItem(2, false);
        accordion.current.expandItem(true, 1);
        break;
      case "Save_Btn":
        if (
          cardNo.current.value != null &&
          cardHolder.current.value !== "" &&
          expiry.current.value != null &&
          cvv.current.value != null
        ) {
          if (checkCardNo(cardNo.current.value)) {
            if (checkCVV(cvv.current.value)) {
              alertDlg.current.content = success;
              alertDlg.current.show();
            }
          }
          err3.current.classList.remove("show");
        } else {
          err3.current.classList.add("show");
        }
        break;
    }
  }
  const checkMail = (mail) => {
    if (/^\w+([.-]?\w+)*@\w+([.-]?\w+)*(\.\w{2,3})+$/.test(mail)) {
      return true;
    } else {
      alertDlg.current.content = email_alert;
      alertDlg.current.show();
      return false;
    }
  }
  const checkMobile = (mobile) => {
    if (/^\d{10}$/.test(mobile.toString())) {
      return true;
    } else {
      alertDlg.current.content = mobile_alert;
      alertDlg.current.show();
      return false;
    }
  }
  const checkCardNo = (cardNo) => {
    if (/^\d{16}$/.test(cardNo.toString())) {
      return true;
    } else {
      alertDlg.current.content = card_alert;
      alertDlg.current.show();
      return false;
    }
  }
  const checkCVV = (cvv) => {
    if (/^\d{3}$/.test(cvv.toString())) {
      return true;
    } else {
      alertDlg.current.content = cvv_alert;
      alertDlg.current.show();
      return false;
    }
  }
  const signForm = () => {
    return (
      <div id="Sign_In_Form">
        <form id="formId">
          <div className="form-group">
            <div className="e-float-input">
              <input type="text" ref={email} name="Email" required />
              <span className="e-float-line" />
              <label className="e-float-text">Email</label>
            </div>
            <div className="e-float-input">
              <input ref={password} type="password" name="Password" required />
              <span className="e-float-line" />
              <label className="e-float-text" htmlFor="password">
                Password
              </label>
            </div>
          </div>
        </form>
        <div style=>
          <button
            className="e-btn"
            id="Continue_Btn"
            onClick={btnClick}
          >
            Continue
          </button>
          <div ref={err1}>* Please fill all fields</div>
        </div>
      </div>
    );
  }
  const addressFill = () => {
    return (
      <div id="Address_Fill">
        <form id="formId_Address">
          <div className="form-group">
            <div className="e-float-input">
              <input type="text" ref={name} name="Name" required />
              <span className="e-float-line" />
              <label className="e-float-text" htmlFor="name">
                Name
              </label>
            </div>
          </div>
          <div className="form-group">
            <div className="e-float-input">
              <input type="text" ref={address} name="Address" required />
              <span className="e-float-line" />
              <label className="e-float-text" htmlFor="address">
                Address
              </label>
            </div>
          </div>
          <div className="form-group">
            <NumericTextBoxComponent
              ref={mobile}
              format="0"
              placeholder="Mobile"
              floatLabelType="Auto"
              showSpinButton={false}
            />
          </div>
        </form>
        <div style=>
          <button
            className="e-btn"
            id="Continue_BtnAdr"
            onClick={btnClick}
          >
            Continue
          </button>
          <div ref={err2}>* Please fill all fields</div>
        </div>
      </div>
    );
  }
  const cardFill = () => {
    return (
      <div id="Card_Fill">
        <div className="col-xs-6 col-sm-6 col-lg-6 col-md-6">
          <div className="form-group">
            <NumericTextBoxComponent
              ref={cardNo}
              format="0"
              placeholder="Card No"
              floatLabelType="Auto"
              showSpinButton={false}
            />
          </div>
        </div>
        <div className="col-xs-6 col-sm-6 col-lg-6 col-md-6">
          <div className="form-group">
            <div className="e-float-input">
              <input type="text" ref={cardHolder} name="cardHolder" required />
              <span className="e-float-line" />
              <label className="e-float-text" htmlFor="cardHolder">
                CardHolder Name
              </label>
            </div>
          </div>
        </div>
        <div className="col-xs-6 col-sm-6 col-lg-6 col-md-6">
          <DatePickerComponent
            ref={expiry}
            width="100%"
            format="MM/yyyy"
            placeholder="Expiry Date"
            floatLabelType="Auto"
          />
        </div>
        <div className="col-xs-6 col-sm-6 col-lg-6 col-md-6">
          <div className="form-group">
            <NumericTextBoxComponent
              ref={cvv}
              format="0"
              placeholder="CVV"
              floatLabelType="Auto"
              showSpinButton={false}
            />
          </div>
        </div>
        <div style=>
          <button
            className="e-btn"
            id="Back_Btn"
            onClick={btnClick}
          >
            Back
          </button>
          <button
            className="e-btn"
            id="Save_Btn"
            onClick={btnClick}
          >
            Save
          </button>
          <div ref={err3}>* Please fill all fields</div>
        </div>
      </div>
    );
  }
  return (
    <div>
      <div className="template_title"> Online Shopping Payment Module</div>
      <DialogComponent
        ref={alertDlg}
        header="Alert"
        width={200}
        isModal={true}
        content=""
        target={dlgTarget}
        buttons={dlgButtons}
        created={dlgCreated}
      />
      <AccordionComponent
        ref={accordion}
        created={acrdnCreated}
      >
        <AccordionItemsDirective>
          <AccordionItemDirective
            expanded={true}
            header="Sign In"
            content={signForm}
          />
          <AccordionItemDirective
            header="Delivery Address"
            content={addressFill}
          />
          <AccordionItemDirective
            header="Card Details"
            content={cardFill}
          />
        </AccordionItemsDirective>
      </AccordionComponent>
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);
import * as React from "react";
import { useRef } from "react";
import * as ReactDOM from "react-dom";
import { DialogComponent } from '@syncfusion/ej2-react-popups';
import { DatePickerComponent } from '@syncfusion/ej2-react-calendars';
import { NumericTextBoxComponent } from '@syncfusion/ej2-react-inputs';
import { AccordionComponent, AccordionItemsDirective, AccordionItemDirective } from '@syncfusion/ej2-react-navigations';
const ReactApp = () => {
  let success: string = "Your payment successfully processed";
  let email_alert: string = "Enter valid email address";
  let mobile_alert: string = "Mobile number length should be 10";
  let card_alert: string = "Card number length should be 16";
  let cvv_alert: string = "CVV number length should be 3";
  let dlgTarget: HTMLElement = document.body;
  const accordion = useRef<AccordionComponent>(null);
  const alertDlg = useRef<DialogComponent>(null);
  const cardNo = useRef<NumericTextBoxComponent>(null);
  const mobile = useRef<NumericTextBoxComponent>(null);
  const expiry = useRef<DatePickerComponent>(null);
  const cvv = useRef<NumericTextBoxComponent>(null);
  const email = useRef(null);
  const password = useRef(null);
  const name = useRef(null);
  const address = useRef(null);
  const cardHolder = useRef(null);
  const err1 = useRef(null);
  const err2 = useRef(null);
  const err3 = useRef(null);
  const dlgButtons: Object[] = [
    {
      buttonModel: { content: "Ok", isPrimary: true },
      click: () => {
        alertDlg.current.hide();
        if (
          accordion.current.expandedIndices[0] === 2 &&
          alertDlg.current.content === success
        ) {
          accordion.current.enableItem(0, true);
          accordion.current.enableItem(1, false);
          accordion.current.enableItem(2, false);
          accordion.current.expandItem(true, 0);
        }
      }
    }
  ];
  const dlgCreated = (): void => {
    alertDlg.current.hide();
  }
  const acrdnCreated = (): void => {
    if (accordion !== undefined) {
      accordion.current.enableItem(1, false);
      accordion.current.enableItem(2, false);
    }
  }
  const btnClick = (e: any): void => {
    switch (e.target.id) {
      case "Continue_Btn":
        if (email.current.value !== "" && password.current.value !== "") {
          if (checkMail(email.current.value)) {
            email.current.value = password.current.value = "";
            accordion.current.enableItem(1, true);
            accordion.current.enableItem(0, false);
            accordion.current.expandItem(true, 1);
          }
          err1.current.classList.remove("show");
        } else {
          err1.current.classList.add("show");
        }
        break;
      case "Continue_BtnAdr":
        if (
          name.current.value !== "" &&
          address.current.value !== "" &&
          mobile.current.value != null
        ) {
          if (checkMobile(mobile.current.value)) {
            accordion.current.enableItem(2, true);
            accordion.current.enableItem(1, false);
            accordion.current.expandItem(true, 2);
          }
          err2.current.classList.remove("show");
        } else {
          err2.current.classList.add("show");
        }
        break;
      case "Back_Btn":
        accordion.current.enableItem(1, true);
        accordion.current.enableItem(2, false);
        accordion.current.expandItem(true, 1);
        break;
      case "Save_Btn":
        if (
          cardNo.current.value != null &&
          cardHolder.current.value !== "" &&
          expiry.current.value != null &&
          cvv.current.value != null
        ) {
          if (checkCardNo(cardNo.current.value)) {
            if (checkCVV(cvv.current.value)) {
              alertDlg.current.content = success;
              alertDlg.current.show();
            }
          }
          err3.current.classList.remove("show");
        } else {
          err3.current.classList.add("show");
        }
        break;
    }
  }
  const checkMail = (mail: string) => {
    if (/^\w+([.-]?\w+)*@\w+([.-]?\w+)*(\.\w{2,3})+$/.test(mail)) {
      return true;
    } else {
      alertDlg.current.content = email_alert;
      alertDlg.current.show();
      return false;
    }
  }
  const checkMobile = (mobile: number) => {
    if (/^\d{10}$/.test(mobile.toString())) {
      return true;
    } else {
      alertDlg.current.content = mobile_alert;
      alertDlg.current.show();
      return false;
    }
  }
  const checkCardNo = (cardNo: number) => {
    if (/^\d{16}$/.test(cardNo.toString())) {
      return true;
    } else {
      alertDlg.current.content = card_alert;
      alertDlg.current.show();
      return false;
    }
  }
  const checkCVV = (cvv: number) => {
    if (/^\d{3}$/.test(cvv.toString())) {
      return true;
    } else {
      alertDlg.current.content = cvv_alert;
      alertDlg.current.show();
      return false;
    }
  }
  const signForm = () => {
    return (
      <div id="Sign_In_Form">
        <form id="formId">
          <div className="form-group">
            <div className="e-float-input">
              <input type="text" ref={email} name="Email" required />
              <span className="e-float-line" />
              <label className="e-float-text">Email</label>
            </div>
            <div className="e-float-input">
              <input ref={password} type="password" name="Password" required />
              <span className="e-float-line" />
              <label className="e-float-text" htmlFor="password">
                Password
              </label>
            </div>
          </div>
        </form>
        <div style=>
          <button
            className="e-btn"
            id="Continue_Btn"
            onClick={btnClick}
          >
            Continue
          </button>
          <div ref={err1}>* Please fill all fields</div>
        </div>
      </div>
    );
  }
  const addressFill = () => {
    return (
      <div id="Address_Fill">
        <form id="formId_Address">
          <div className="form-group">
            <div className="e-float-input">
              <input type="text" ref={name} name="Name" required />
              <span className="e-float-line" />
              <label className="e-float-text" htmlFor="name">
                Name
              </label>
            </div>
          </div>
          <div className="form-group">
            <div className="e-float-input">
              <input type="text" ref={address} name="Address" required />
              <span className="e-float-line" />
              <label className="e-float-text" htmlFor="address">
                Address
              </label>
            </div>
          </div>
          <div className="form-group">
            <NumericTextBoxComponent
              ref={mobile}
              format="0"
              placeholder="Mobile"
              floatLabelType="Auto"
              showSpinButton={false}
            />
          </div>
        </form>
        <div style=>
          <button
            className="e-btn"
            id="Continue_BtnAdr"
            onClick={btnClick}
          >
            Continue
          </button>
          <div ref={err2}>* Please fill all fields</div>
        </div>
      </div>
    );
  }
  const cardFill = () => {
    return (
      <div id="Card_Fill">
        <div className="col-xs-6 col-sm-6 col-lg-6 col-md-6">
          <div className="form-group">
            <NumericTextBoxComponent
              ref={cardNo}
              format="0"
              placeholder="Card No"
              floatLabelType="Auto"
              showSpinButton={false}
            />
          </div>
        </div>
        <div className="col-xs-6 col-sm-6 col-lg-6 col-md-6">
          <div className="form-group">
            <div className="e-float-input">
              <input type="text" ref={cardHolder} name="cardHolder" required />
              <span className="e-float-line" />
              <label className="e-float-text" htmlFor="cardHolder">
                CardHolder Name
              </label>
            </div>
          </div>
        </div>
        <div className="col-xs-6 col-sm-6 col-lg-6 col-md-6">
          <DatePickerComponent
            ref={expiry}
            width="100%"
            format="MM/yyyy"
            placeholder="Expiry Date"
            floatLabelType="Auto"
          />
        </div>
        <div className="col-xs-6 col-sm-6 col-lg-6 col-md-6">
          <div className="form-group">
            <NumericTextBoxComponent
              ref={cvv}
              format="0"
              placeholder="CVV"
              floatLabelType="Auto"
              showSpinButton={false}
            />
          </div>
        </div>
        <div style=>
          <button
            className="e-btn"
            id="Back_Btn"
            onClick={btnClick}
          >
            Back
          </button>
          <button
            className="e-btn"
            id="Save_Btn"
            onClick={btnClick}
          >
            Save
          </button>
          <div ref={err3}>* Please fill all fields</div>
        </div>
      </div>
    );
  }
  return (
    <div>
      <div className="template_title"> Online Shopping Payment Module</div>
      <DialogComponent
        ref={alertDlg}
        header="Alert"
        width={200}
        isModal={true}
        content=""
        target={dlgTarget}
        buttons={dlgButtons}
        created={dlgCreated}
      />
      <AccordionComponent
        ref={accordion}
        created={acrdnCreated}
      >
        <AccordionItemsDirective>
          <AccordionItemDirective
            expanded={true}
            header="Sign In"
            content={signForm}
          />
          <AccordionItemDirective
            header="Delivery Address"
            content={addressFill}
          />
          <AccordionItemDirective
            header="Card Details"
            content={cardFill}
          />
        </AccordionItemsDirective>
      </AccordionComponent>
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2 React Accordion Sample</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/material.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body id="container">
    <div id='element'>
        <div id='loader'>Loading....</div>
    </div>
</body>
</html>
#container {
    max-width: 450px;
    margin: 0 auto;
}

#loader {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

.accordion-control-section {
    margin: 0 10% 0 10%;
}

@media screen and (max-width: 768px) {
    .accordion-control-section {
        margin: 0;
    }
}

#err1, #err2, #err3 {
    display: none;
    color: red;
    margin-top: 10px;
    font-weight: 500;
}

#err1.show,
#err2.show,
#err3.show {
    display: block;
}

.e-dialog {
    max-height: 300px !important; /* csslint allow: important */
}

.template_title {
    text-align: center;
    padding: 10px 0;
    margin: 20px 0;
    text-overflow: ellipsis;
    font-weight: bold;
    font-size: 16px;
}

Create wizard using accordion in Angular Accordion component

17 Sep 202524 minutes to read

Accordion items can be disabled dynamically by passing the index and boolean value with the enableItem method and also dynamically expand the item using expandItem method.

The below Wizard sample is designed for Online Shopping model. In this, each Accordion item is integrated with required components to fill the details and designed for getting user details and making payment at the end. Each field is provided with validation for all mandatory option to enable/disable to next Accordion. In below sample, accordion items can be disabled dynamically with enableItem method using created event.

<ejs-dialog #alertDlg header='Alert' width=200 isModal=true content='' [target]='dlgTarget' [buttons]='dlgButtons'
    (created)='dlgCreated()'></ejs-dialog>

<ejs-accordion #accordion (created)='acrdnCreated()'>
    <e-accordionitems>
        <e-accordionitem expanded='true' header='Sign In'>
            <ng-template #content>
                <div id="Sign_In_Form" style="padding: 3px 0">
                    <form id="formId">
                        <div class="form-group">
                            <div class="e-float-input">
                                <input type="text" id="email" name="Email" required="" #emailRef/>
                                <span class="e-float-line"></span>
                                <label class="e-float-text" for="email">Email</label>
                            </div>
                            <div class="e-float-input">
                                <input id="password" type="password" name="Password" required="" #passwordRef/>
                                <span class="e-float-line"></span>
                                <label class="e-float-text" for="password">Password</label>
                            </div>
                        </div>
                    </form>
                    <div style="text-align: center">
                        <button class='e-btn' id="Continue_Btn" (click)='btnClick($event)'>Continue</button>
                        <div id="err1" #error1>* Please fill all fields</div>
                    </div>
                </div>
            </ng-template>
        </e-accordionitem>
        <e-accordionitem header='Delivery Address'>
            <ng-template #content>
                <div id="Address_Fill" style="padding: 3px 0">
                    <form id="formId_Address">
                        <div class="form-group">
                            <div class="e-float-input">
                                <input type="text" id="name" name="Name" required="" #nameRef/>
                                <span class="e-float-line"></span>
                                <label class="e-float-text" for="name">Name</label>
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="e-float-input">
                                <input type="text" id="address" name="Address" required="" #addressRef/>
                                <span class="e-float-line"></span>
                                <label class="e-float-text" for="address">Address</label>
                            </div>
                        </div>
                        <div class="form-group">
                            <ejs-numerictextbox #mobile format='0' placeholder='Mobile' floatLabelType='Auto'
                                [showSpinButton]=false></ejs-numerictextbox>
                        </div>
                    </form>
                    <div style="text-align: center">
                        <button class='e-btn' id="Continue_BtnAdr" (click)='btnClick($event)'>Continue</button>
                        <div id="err2" #error2>* Please fill all fields</div>
                    </div>
                </div>
            </ng-template>
        </e-accordionitem>
        <e-accordionitem header='Card Details'>
            <ng-template #content>
                <div id="Card_Fill" style="padding: 3px 0;">
                    <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6">
                        <div class="form-group">
                            <ejs-numerictextbox #cardNo format='0' placeholder='Card No' floatLabelType='Auto'
                                [showSpinButton]=false></ejs-numerictextbox>
                        </div>
                    </div>
                    <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6">
                        <div class="form-group">
                            <div class="e-float-input">
                                <input type="text" id="cardHolder" name="cardHolder" required="" #cardHolderRef/>
                                <span class="e-float-line"></span>
                                <label class="e-float-text" for="cardHolder">CardHolder Name</label>
                            </div>
                        </div>
                    </div>
                    <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6">
                        <ejs-datepicker #date width='100%' format='MM/yyyy' placeholder='Expiry Date'
                            floatLabelType='Auto'></ejs-datepicker>
                    </div>
                    <div class="col-xs-6 col-sm-6 col-lg-6 col-md-6">
                        <div class="form-group">
                            <ejs-numerictextbox #cvv format='0' placeholder='CVV' floatLabelType='Auto'
                                [showSpinButton]=false></ejs-numerictextbox>
                        </div>
                    </div>
                    <div style="text-align: center">
                        <button class='e-btn' id="Back_Btn" (click)='btnClick($event)'>Back</button>
                        <button class='e-btn' id="Save_Btn" (click)='btnClick($event)'>Save</button>
                        <div id="err3" #error1>* Please fill all fields</div>
                    </div>
                </div>
            </ng-template>
        </e-accordionitem>
    </e-accordionitems>
</ejs-accordion>
import { BrowserModule } from '@angular/platform-browser'
import { NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core'
import { DialogAllModule } from '@syncfusion/ej2-angular-popups'
import { DatePickerAllModule } from '@syncfusion/ej2-angular-calendars'
import { NumericTextBoxAllModule } from '@syncfusion/ej2-angular-inputs'
import { AccordionModule } from '@syncfusion/ej2-angular-navigations'

import { Component, ViewChild, OnInit } from '@angular/core';
import { enableRipple, isNullOrUndefined as isNOU } from '@syncfusion/ej2-base';
import { DialogComponent } from '@syncfusion/ej2-angular-popups';
import { DatePicker } from '@syncfusion/ej2-calendars';
import { NumericTextBoxComponent } from '@syncfusion/ej2-angular-inputs';
import { AccordionComponent, AccordionItemsDirective, AccordionItemDirective } from '@syncfusion/ej2-angular-navigations';
import { DatePickerComponent } from '@syncfusion/ej2-angular-calendars';
import { ElementRef } from '@angular/core';

enableRipple(true);

@Component({
imports: [
        
        DialogAllModule,
        AccordionModule,
        DatePickerAllModule,
        NumericTextBoxAllModule
    ],


standalone: true,
  selector: 'app-container',
  templateUrl: './app.component.html'
})

export class AppComponent implements OnInit {
  @ViewChild('alertDlg') alertDlg?: DialogComponent;
  @ViewChild('accordion') accordion?: AccordionComponent;
  @ViewChild('mobile') mobile?: NumericTextBoxComponent;
  @ViewChild('cardNo') cardNo?: NumericTextBoxComponent;
  @ViewChild('date') expiry?: DatePickerComponent;
  @ViewChild('cvv') cvv?: NumericTextBoxComponent;
  @ViewChild('emailRef') emailReference!: ElementRef<HTMLInputElement>;
  @ViewChild('passwordRef') passwordRef!: ElementRef<HTMLInputElement>;
  @ViewChild('nameRef') nameRef!: ElementRef<HTMLInputElement>;
  @ViewChild('addressRef') addressRef!: ElementRef<HTMLInputElement>;
  @ViewChild('cardHolderRef') cardHolderRef!: ElementRef<HTMLInputElement>;
  @ViewChild('error1') error1!: ElementRef<HTMLDivElement>;
  @ViewChild('error2') error2!: ElementRef<HTMLDivElement>;
  @ViewChild('error3') error3!: ElementRef<HTMLDivElement>;

  public dlgTarget?: HTMLElement;
  public dlgButtons?: Object[];
  public success: string = 'Your payment successfully processed';
  public email_alert: string = 'Enter valid email address';
  public mobile_alert: string = 'Mobile number length should be 10';
  public card_alert: string = 'Card number length should be 16';
  public cvv_alert: string = 'CVV number length should be 3';

  public ngOnInit(): void {
    this.dlgTarget = document.body;
    this.dlgButtons = [{
      buttonModel: { content: 'Ok', isPrimary: true },
        click: (() => {
          this.alertDlg?.hide();
          if ((this.accordion as AccordionComponent).expandedIndices[0] === 2 && this.alertDlg?.content === this.success) {
            (this.accordion as AccordionComponent).enableItem(0, true);
            (this.accordion as AccordionComponent).enableItem(1, false);
            (this.accordion as AccordionComponent).enableItem(2, false);
            (this.accordion as AccordionComponent).expandItem(true, 0);
          }
        })
      }];
  }

  public dlgCreated(): void {
    this.alertDlg?.hide();
  }

  public acrdnCreated(): void {
   (this.accordion as AccordionComponent).enableItem(1, false);
   (this.accordion as AccordionComponent).enableItem(2, false);
  }

  public btnClick(e: any): void {
    switch (e.target.id) {
      case 'Continue_Btn':
        let email: string | any = this.emailReference.nativeElement.value;
        let password: string | any = this.passwordRef.nativeElement.value;
        if(email !== '' && password !== '') {
          if(this.checkMail(email)) {
            email = password = '';
            (this.accordion as AccordionComponent).enableItem(1, true);
            (this.accordion as AccordionComponent).enableItem(0, false);
            (this.accordion as AccordionComponent).expandItem(true, 1);
          }
          this.error1.nativeElement.classList.remove('show');
        } else {
          this.error1.nativeElement.classList.add('show');
        }
        break;
      case 'Continue_BtnAdr':
        let name: string | any = this.nameRef.nativeElement.value;
        let address: string | any = this.addressRef.nativeElement.value;
        if((name !== '') && (address !== '') && (!isNOU((this.mobile as NumericTextBoxComponent).value))) {
          if(this.checkMobile((this.mobile as NumericTextBoxComponent).value)) {
            (this.accordion as AccordionComponent).enableItem(2, true);
            (this.accordion as AccordionComponent).enableItem(1, false);
            (this.accordion as AccordionComponent).expandItem(true, 2);
          }
          this.error2.nativeElement.classList.remove('show');
        } else {
          this.error2.nativeElement.classList.add('show');
        }
        break;
      case 'Back_Btn':
        (this.accordion as AccordionComponent).enableItem(1, true);
        (this.accordion as AccordionComponent).enableItem(2, false);
        (this.accordion as AccordionComponent).expandItem(true, 1);
        break;
      case 'Save_Btn':
        let cardHolder: string | any = this.cardHolderRef.nativeElement.value;
        if(!isNOU((this.cardNo as NumericTextBoxComponent).value) && (cardHolder !== '') && (!isNOU((this.expiry as DatePickerComponent).value)) && !isNOU((this.cvv as NumericTextBoxComponent).value)) {
          if (this.checkCardNo((this.cardNo as NumericTextBoxComponent).value)) {
            if (this.checkCVV((this.cvv as NumericTextBoxComponent).value)) {
              (this.alertDlg as DialogComponent).content = this.success;
              (this.alertDlg as DialogComponent).show();
            }
          }
          this.error3.nativeElement.classList.remove('show');
        } else {
          this.error3.nativeElement.classList.add('show');
        }
        break;
    }
  }

  public checkMail(mail: string) {
    if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(mail)) {
      return true;
    } else {
      (this.alertDlg as DialogComponent).content = this.email_alert;
      (this.alertDlg as DialogComponent).show();
      return false;
    }
  }

  public checkMobile(mobile: number) {
    if (/^\d{10}$/.test(mobile as any)) {
      return true;
    } else {
      (this.alertDlg as DialogComponent).content = this.mobile_alert;
      (this.alertDlg as DialogComponent).show();
      return false;
    }
  }

  public checkCardNo(cardNo: number) {
    if (/^\d{16}$/.test(cardNo as any)) {
      return true;
    } else {
      (this.alertDlg as DialogComponent).content = this.card_alert;
      (this.alertDlg as DialogComponent).show();
      return false;
    }
  }

  public checkCVV(cvv: number) {
    if (/^\d{3}$/.test(cvv as any)) {
      return true;
    } else {
      (this.alertDlg as DialogComponent).content = this.cvv_alert;
      (this.alertDlg as DialogComponent).show();
      return false;
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));